using System;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace SampleUltraTreeLoaderFromList
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
      
        private void Form1_Load(object sender, EventArgs e)
        {
            TreeList treeList = new TreeList();
            DataTable dataTable =new DataTable("Table1");
            DataColumn dataColumn1 =new DataColumn("Col1");
            DataColumn dataColumn2 = new DataColumn("Col2");
            dataTable.Columns.Add(dataColumn1);
            dataTable.Columns.Add(dataColumn2);
            dataTable.Rows.Add("A", "B");


            TreeListItem item1 = new TreeListItem(dataTable, "Text:Overview Window");
            treeList.Add(item1);

            TreeListItem subitem = new TreeListItem(dataTable, "Text:Overview 1");
            TreeListItem subitem3 = new TreeListItem(dataTable, "Text:Overview 1.1");
            subitem.TreeListSubItems.Add(subitem3);
            TreeListItem subitem4 = new TreeListItem(dataTable, "Text:Overview 1.1.1");
            subitem3.TreeListSubItems.Add(subitem4);
            item1.TreeListSubItems.Add(subitem);

            item1.TreeListSubItems.Add(new TreeListItem(dataTable, "Text:Overview 2"));
            item1.TreeListSubItems.Add(new TreeListItem(dataTable, "Text:Overview 3"));

            Bind(treeList);
          
        }
        private void Bind(TreeList treeList)
        {
            UltraTree ultraTree = new UltraTree();
            ultraTree.DataSource = treeList;
            ultraTree.Dock = DockStyle.Fill;
            ultraTree.ViewStyle = ViewStyle.Standard;
            ultraTree.Override.ShowExpansionIndicator = ShowExpansionIndicator.CheckOnDisplay;
            ultraTree.ExpandAll();
            Controls.Add(ultraTree);
            ultraTree.InitializeDataNode +=OnInitializeDataNode;
            
        }

        private static void OnInitializeDataNode(object sender, InitializeDataNodeEventArgs e)
        {
           if(e.Node.Text=="Text:Overview 2")
           {
               e.Node.Visible = false;
           }
        }   
    }
    

    public class TreeList : BindingList<TreeListItem>
    {
    }
    public class TreeListItem
    {
        private string _name;
        private DataTable _key;

        private BindingList<TreeListItem> _treeListSubItems = new BindingList<TreeListItem>();

        
        public TreeListItem(DataTable key, string itemName)
        {
            _name = itemName;
            _key = key;
           
        }
        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }
        public DataTable Key
        {
            get { return _key; }
            set { _key = value; }
        }

        public BindingList<TreeListItem> TreeListSubItems
        {
            get { return _treeListSubItems; }
            set { _treeListSubItems = value; }
        }
    }
}